﻿using System;

namespace ConsoleApp1
{
    class Log
    {
        public void Rejestruj(string komunikat)
        {
            Console.WriteLine("Log: " + komunikat);
        }
    }

    class KlasaA
    {
        private Log log;

        public KlasaA(Log log)
        {
            this.log = log;
        }

        public void Metoda1()
        {
            log.Rejestruj("KlasaA.Metoda1");
        }
    }

    class KlasaB
    {
        private Log log;
        KlasaA obiektA;

        public KlasaB(Log log)
        {
            this.log = log;
            this.obiektA = new KlasaA(log);
        }

        public void Metoda1()
        {

            log.Rejestruj("KlasaB.Metoda1");
        }

        public void Metoda2()
        {
            log.Rejestruj("KlasaB.Metoda2");
        }
    }


    class Program
    {
        static void Main(string[] args)
        {
            Log log = new Log();

            KlasaA obiektA = new KlasaA(log);
            obiektA.Metoda1();
            KlasaB obiektB = new KlasaB(log);
            obiektB.Metoda1();
            obiektB.Metoda2();
        }

    }
}
